﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using iTextSharp.text.pdf;

namespace iTextSharpSign
{
    public partial class Form1 : Form
    {

        private const string MenuName = "AcroExch.Document.7\\shell\\Firma";
        public const string Command = "AcroExch.Document.7\\shell\\Firma\\command";

        public Form1(string archivo)
        {
            InitializeComponent();
            this.inputBox.Text = archivo;
        }


        private void debug(string txt)
        {
            DebugBox.AppendText(txt + System.Environment.NewLine);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.OpenFileDialog openFile;
            openFile = new System.Windows.Forms.OpenFileDialog();
            openFile.Filter = "PDF files *.pdf|*.pdf";
            openFile.Title = "Select a file";
            if (openFile.ShowDialog() != DialogResult.OK)
                return;

            inputBox.Text = openFile.FileName;


            PdfReader reader = new PdfReader(inputBox.Text);

            MetaData md = new MetaData();
            md.Info = reader.Info;

            authorBox.Text = md.Author;
            titleBox.Text = md.Title;
            subjectBox.Text = md.Subject;
            kwBox.Text = md.Keywords;
            creatorBox.Text = md.Creator;
            prodBox.Text = md.Producer;

        }

        private void button5_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.SaveFileDialog saveFile;
            saveFile = new System.Windows.Forms.SaveFileDialog();            
            saveFile.Filter = "PDF files (*.pdf)|*.pdf";
            saveFile.Title = "Save PDF File";
            if (saveFile.ShowDialog() != DialogResult.OK)
                return;
            outputBox.Text = saveFile.FileName;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.OpenFileDialog openFile;
            openFile = new System.Windows.Forms.OpenFileDialog();
            openFile.Filter = "Certificate files *.pfx|*.pfx";
            openFile.Title = "Select a file";
            if (openFile.ShowDialog() != DialogResult.OK)
                return;

            certTextBox.Text = openFile.FileName;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            debug("Started ...");

            debug("Checking certificate ...");
            Cert myCert=null;
            try
            {
                myCert = new Cert(certTextBox.Text, passwordBox.Text);
                debug("Certificate OK");
            }
            catch (Exception ex)
            {                
                debug("Error : please make sure you entered a valid certificate file and password");
                debug("Exception : "+ex.ToString());
                return;
            }


            debug("Creating new MetaData ... ");

            //Adding Meta Datas
            MetaData MyMD = new MetaData();
            MyMD.Author = authorBox.Text;
            MyMD.Title = titleBox.Text;
            MyMD.Subject = subjectBox.Text;
            MyMD.Keywords = kwBox.Text;
            MyMD.Creator = creatorBox.Text;
            MyMD.Producer = prodBox.Text;


            debug("Signing document ... ");
            PDFSigner pdfs = new PDFSigner(inputBox.Text, outputBox.Text, myCert, MyMD);
            pdfs.Sign(Reasontext.Text, Contacttext.Text, Locationtext.Text, SigVisible.Checked);

            debug("Done :)");

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //RegistrarMenu();
        }
        private void RegistrarMenu()
        {
            RegistryKey regmenu = null;
            RegistryKey regcmd = null;
            try
            {
                regmenu = Registry.ClassesRoot.CreateSubKey(MenuName);
                if (regmenu != null)
                    regmenu.SetValue("", "Firma Digital...");
                regcmd = Registry.ClassesRoot.CreateSubKey(Command);
                if (regcmd != null)
                    regcmd.SetValue("", Application.StartupPath);

            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.ToString());
            }
            finally
            {
                if (regmenu != null)
                    regmenu.Close();
                if (regcmd != null)
                    regcmd.Close();
            }
        }
        private void AsociarExtension()
        {
            RegistryKey root = Registry.ClassesRoot;                  //  HKEY_CLASSES_ROOT registry section      
            RegistryKey fileType = root.OpenSubKey(".cbv");         // retrieve the registry key for the .bvc       
            if (fileType == null)                                     // Was the file type found?
            {
                RegistryKey clave = root.CreateSubKey(".cbv");          // Create the registry key
                clave.SetValue("", "Confrontacion.file");               // Set the unique file type name
                RegistryKey info = root.CreateSubKey("Confrontacion.file");// Create the file type information key
                info.SetValue("", "Confrontacion Batalla Virtual");   // Set the default value to the file type description
                RegistryKey shell = info.CreateSubKey("shell");     // Create the shell key to contain all verbs
                RegistryKey abrir = shell.CreateSubKey("Open");      // Create a subkey for the "Open" verb
                abrir.SetValue("", "&Abrir con Confrontación BV");     // Set the menu name against the key
                clave = abrir.CreateSubKey("command");                 // Create and set the command string
                clave.SetValue("", Application.StartupPath + "\\confrontacion.exe %1");
                clave = info.CreateSubKey("DefaultIcon");             // Assign a default icon
                clave.SetValue("", Application.StartupPath + "\\confrontacion.exe");
            }


        }

    }
}